package com.paypal;

import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.concurrent.TimeUnit;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.JSONObject;

import okhttp3.ConnectionSpec;
import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;
import okhttp3.TlsVersion;

/**
 * Servlet implementation class DoEC
 */

/*	This	 call takes token,payerID and total amount to be paid and executes the payment.
 	It returns status of the transaction and the token	*/

@WebServlet("/executePayment")
public class DoEC extends HttpServlet {
	private static final long serialVersionUID = 1L;
	
    /**
     * @see HttpServlet#HttpServlet()
     */
    
    private static String USER ;
    private static String PWD ;
    private static String SIGNATURE ;
    private static String VERSION ;
    private static String METHOD ;
    private static String PAYMENTREQUEST_0_PAYMENTACTION ="";
    private static String PAYMENTREQUEST_0_CURRENCYCODE = "";
	private static String PAYMENTREQUEST_0_AMT = "";
	private static String PAYMENTREQUEST_0_ITEMAMT = "";
	private static String L_PAYMENTREQUEST_0_QTY0 = "";
	private static String L_PAYMENTREQUEST_0_AMT0 = "";
	private static String PAYMENTREQUEST_0_INSURANCEAMT = "";
	private static String PAYMENTREQUEST_0_TAXAMT = "";
	private static String PAYMENTREQUEST_0_SHIPDISCAMT = "";
	private static String PAYMENTREQUEST_0_HANDLINGAMT = "";
	private static String PAYMENTREQUEST_0_SHIPPINGAMT = "";
    private static String URL = "https://api-3t.sandbox.paypal.com/nvp";
    private static JSONObject obj;
    private static String userActionFlag;
    private static String environment;
    
    
    public JSONObject makeDoEC(String payerID, String paymentID ) throws Exception {
    	
    	
    	
    	ConnectionSpec cs = new ConnectionSpec.Builder(ConnectionSpec.MODERN_TLS) // Set TLS VERSION 1.2
                .tlsVersions(TlsVersion.TLS_1_2)
                .build();
        List<ConnectionSpec> specs = new ArrayList<ConnectionSpec>();
            specs.add(cs);
            specs.add(ConnectionSpec.COMPATIBLE_TLS);
            specs.add(ConnectionSpec.CLEARTEXT);
            
        OkHttpClient client = new OkHttpClient.Builder()
                .connectTimeout(36000, TimeUnit.SECONDS)
                .writeTimeout(36000, TimeUnit.SECONDS)
                .readTimeout(36000, TimeUnit.SECONDS)
                .connectionSpecs(specs)
                .build();
		MediaType mediaType = MediaType.parse("application/octet-stream");
    	
    	Properties prop = new Properties();
    	InputStream input = null;
    	String filename = "config/config.properties";
    	
    	input = this.getClass().getClassLoader().getResourceAsStream(filename);  
    	if(input==null){
    		System.out.println("Sorry, unable to find "+filename);
    		JSONObject error = new JSONObject();
    		return error;
    	}
    	
    	try {
    		prop.load(input);
    		this.setUserActionFlag(prop.getProperty("USERACTION_FLAG"));
    		String strSandbox="";
    		if(prop.getProperty("SANDBOX_FLAG").equals("true")){
    			strSandbox="_SANDBOX";
    			environment = "sandbox";
    			USER = prop.getProperty("USER");
    			PWD = prop.getProperty("PWD");
    			SIGNATURE = prop.getProperty("SIGNATURE");
    			URL = prop.getProperty("SANDBOX_URL");
    		}
    		else {
    			USER = prop.getProperty("LIVE_USER");
    			PWD = prop.getProperty("LIVE_PWD");
    			SIGNATURE = prop.getProperty("LIVE_SIGNATURE");
    			URL = prop.getProperty("LIVE_URL");
    		}
    		VERSION = prop.getProperty("VERSION");
    		METHOD = prop.getProperty("DoEC_METHOD");
    		
    		try {
    			String nvpstr = "USER=" + URLEncoder.encode(USER, "UTF-8");
    			nvpstr = nvpstr + "&PWD=" + URLEncoder.encode(PWD, "UTF-8");
    			nvpstr = nvpstr + "&SIGNATURE=" + URLEncoder.encode(SIGNATURE, "UTF-8");
    			nvpstr = nvpstr + "&VERSION=" + URLEncoder.encode(VERSION, "UTF-8");
    			nvpstr = nvpstr + "&METHOD=" + URLEncoder.encode(METHOD, "UTF-8");
    			nvpstr = nvpstr + "&TOKEN=" + URLEncoder.encode(paymentID, "UTF-8");
    			nvpstr = nvpstr + "&PAYERID=" + URLEncoder.encode(payerID, "UTF-8");
    			nvpstr = nvpstr + "&PAYMENTREQUEST_0_PAYMENTACTION=" + URLEncoder.encode(PAYMENTREQUEST_0_PAYMENTACTION, "UTF-8");
    			nvpstr = nvpstr + "&PAYMENTREQUEST_0_CURRENCYCODE=" + URLEncoder.encode(PAYMENTREQUEST_0_CURRENCYCODE, "UTF-8");
			nvpstr = nvpstr + "&PAYMENTREQUEST_0_AMT=" + URLEncoder.encode(PAYMENTREQUEST_0_AMT, "UTF-8");
			nvpstr = nvpstr + "&PAYMENTREQUEST_0_ITEMAMT=" + URLEncoder.encode(PAYMENTREQUEST_0_ITEMAMT, "UTF-8");
			nvpstr = nvpstr + "&L_PAYMENTREQUEST_0_QTY0=" + URLEncoder.encode(L_PAYMENTREQUEST_0_QTY0, "UTF-8");
			nvpstr = nvpstr + "&L_PAYMENTREQUEST_0_AMT0=" + URLEncoder.encode(L_PAYMENTREQUEST_0_AMT0, "UTF-8");
			nvpstr = nvpstr + "&PAYMENTREQUEST_0_INSURANCEAMT=" + URLEncoder.encode(PAYMENTREQUEST_0_INSURANCEAMT, "UTF-8");
			nvpstr = nvpstr + "&PAYMENTREQUEST_0_TAXAMT=" + URLEncoder.encode(PAYMENTREQUEST_0_TAXAMT, "UTF-8");
			nvpstr = nvpstr + "&PAYMENTREQUEST_0_SHIPDISCAMT=" + URLEncoder.encode(PAYMENTREQUEST_0_SHIPDISCAMT, "UTF-8");
			nvpstr = nvpstr + "&PAYMENTREQUEST_0_HANDLINGAMT=" + URLEncoder.encode(PAYMENTREQUEST_0_HANDLINGAMT, "UTF-8");
			nvpstr = nvpstr + "&PAYMENTREQUEST_0_SHIPPINGAMT=" + URLEncoder.encode(PAYMENTREQUEST_0_SHIPPINGAMT, "UTF-8");
    			
    			RequestBody body = RequestBody.create(mediaType, nvpstr);
    			
    			Request request = new Request.Builder()
    			.url(URL)
    			.post(body)
    			.addHeader("cache-control", "no-cache")
    			.build();
    			
    			try {
    				Response response = client.newCall(request).execute();
    				String payload = response.body().string();
    				obj=deformatNVP(payload);
    				System.out.println("From DoEC:\n"+obj);
    				
    				
    				
    				
    			} catch (IOException e) {
    				e.printStackTrace();
    				throw new Exception("Server Error");
    			}
    			
    		} catch (UnsupportedEncodingException e) {
    			e.printStackTrace();
    		}
    	} catch (IOException e1) {
    		e1.printStackTrace();
    	}
    	return obj;
    	
    }
    
    public static JSONObject deformatNVP(String payload) {
    	
    	HashMap nvp = new HashMap(); 
    	StringTokenizer stTok = new StringTokenizer( payload, "&");
    	
    	while (stTok.hasMoreTokens())
    	{
    		StringTokenizer stInternalTokenizer = new StringTokenizer( stTok.nextToken(), "=");
    		if (stInternalTokenizer.countTokens() == 2)
    		{
    			String key = URLDecoder.decode( stInternalTokenizer.nextToken());
    			String value = URLDecoder.decode( stInternalTokenizer.nextToken());
    			nvp.put( key.toUpperCase(), value );
    		}
    	}
    	
    	nvp.put("id",nvp.get("TOKEN"));

    	nvp.put("status", nvp.get("ACK"));
    	nvp.put("paymentID", nvp.get("id"));
    	System.out.println("NVP data:\n"+nvp);
    	JSONObject json = new JSONObject(nvp);
    	return json;
    }


	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response){
		PrintWriter writer = null;
		try {
			writer  = response.getWriter();
			String payerID = request.getParameter("payerID");
			String paymentID = request.getParameter("id");
			PAYMENTREQUEST_0_CURRENCYCODE=request.getParameter("cc");
			PAYMENTREQUEST_0_AMT=request.getParameter("amt");
			PAYMENTREQUEST_0_ITEMAMT=request.getParameter("item_amt");
			L_PAYMENTREQUEST_0_QTY0=request.getParameter("qty_0");
			L_PAYMENTREQUEST_0_AMT0=request.getParameter("amt_0");
			PAYMENTREQUEST_0_INSURANCEAMT = request.getParameter("insurance_amt");
			PAYMENTREQUEST_0_TAXAMT = request.getParameter("tax_amt");
			PAYMENTREQUEST_0_SHIPDISCAMT = request.getParameter("shipdisc_amt");
			PAYMENTREQUEST_0_HANDLINGAMT = request.getParameter("hand_amt");
			PAYMENTREQUEST_0_SHIPPINGAMT = request.getParameter("ship_amt");
			
			System.out.println(PAYMENTREQUEST_0_CURRENCYCODE);
			
			JSONObject obj1 = makeDoEC(payerID,paymentID);
			
			writer.println(obj);
		}
		catch (Exception e) {
			e.printStackTrace();
			System.out.println("From doEC errormess:\n"+e.getMessage());
			String error = "ACK=Failure&L_LONGMESSAGE0="+URLEncoder.encode(e.getMessage());
			JSONObject errmess = deformatNVP(error);
			System.out.println(errmess);
			writer.println(errmess);
		}
		
	}
	
	private void setUserActionFlag(String userActionFlag) {
		this.userActionFlag = userActionFlag;
	}

}